/**
 *  Module provides access to widget metadata in info.plist
 */
 var WidgetMeta = {
   cache:{}
};

WidgetMeta.getKeyValue = function(plist, key) {
    if(WidgetMeta.cache[key]) return WidgetMeta.cache[key];
    var xml_http = new XMLHttpRequest();
    if(xml_http.overrideMimeType) xml_http.overrideMimeType("text/xml");
    xml_http.open("GET", plist, false);
    xml_http.send(null); 
    var xml = xml_http.responseXML;
    var key_value = null;
    var dictnodes = xml.getElementsByTagName("dict");
    
    var nodes=dictnodes[0].childNodes; 
    
    for(var i=0; i < nodes.length; i++) 
    {
	if (nodes[i].nodeType == 1 && nodes[i].tagName.toLowerCase()
            == "key" && nodes[i].firstChild.data == key) {
	    if (nodes[i+2].tagName.toLowerCase() != "array") {
		key_value = nodes[i+2].firstChild.data;
	    } else {
		key_value = new Array();
		var ar_nodes = nodes[i+2].childNodes;
		for (var j=0; j < ar_nodes.length; j++)
		{
		    if (ar_nodes[j].nodeType == 1)
			key_value.push(ar_nodes[j].firstChild.data);
		}
		ar_nodes = null;
	    } 
	    
	    break;
	}
    }
    xml_http = null;
    xml = null;
    WidgetMeta.cache[key]=key_value;
    return key_value;    
};
